/*
 *  sound.hpp
 *  Template
 *
 *  Created by increpare on 16/01/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include <aldumb.h>

const int pan = 128;
const int volume = 128;

DUH* music[0];
SAMPLE* sample[1];

AL_DUH_PLAYER *dplay=NULL; /* Holds the current playback state. */

void stopnotes()
{
	stop_sample(sample[0]);	
}

void stopmusic()
{
	//BASS_ChannelStop(curplay);
	if (dplay)
	{
		al_stop_duh(dplay);
		dplay=NULL;
	}
}

int curtrack=0;

void playmusic(int i)
{
	curtrack=i;
	stopmusic();

	dplay=al_start_duh(music[i],2,0,0.2f, 4096,2000);
}

void ultrahifi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,22000);
}

void hifi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,4000);
}

void midfi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,2000);
}


void lofi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,1000);
}


void ultralofi()
{
	long l=0;
	if (dplay)
		l=al_duh_get_position(dplay);
	stopmusic();
	dplay=al_start_duh(music[curtrack],2,l,0.2f,4096,500);
}

void playsample(int i, int pitch=1000)
{
	play_sample(sample[i], volume, pan, pitch, 0);
}


//0 is G4
void playnote(int note)
{
//	std::cout<<"n "<<note<<endl;
	playsample(0,1000.0f*pow(1.0594630943593,note));
}


void init_sound()
{

	if (install_sound(DIGI_AUTODETECT, MIDI_NONE, NULL) != 0) {
		allegro_message("Error initialising sound system\n%s\n", allegro_error);
	}
	atexit(&dumb_exit);
	set_mixer_quality(2);
	dumb_register_stdfiles();

	sample[0] = load_sample("wav/G4.wav");

	//load music
//	music[0] = dumb_load_xm_quick("xm/b1.xm");
}
